## command-graph command-graph |

## Synopsis

    #define             MAX_NUM_PREDICTIONS
    void                command_graph_free                  (const Command_Graph graph);
    Command_Graph       command_graph_create                ();
    void                command_graph_add_vertex            (const Command_Graph graph,
                                                             const Command_Vertex vertex);
    const Command_Vertex * command_graph_get_last_n_added_vertices
                                                            (const Command_Graph graph);
    void                command_graph_remove_vertex         (const Command_Graph graph,
                                                             const Command_Vertex vertex);
    Command_Vertex      command_graph_get_vertex            (const Command_Graph graph,
                                                             const Command_Vertex vertex);
    int                 command_graph_size                  (const Command_Graph graph);
    int                 command_graph_total_commands        (const Command_Graph graph);
    Arraylist           command_graph_get_vertices          (const Command_Graph graph);
    Command_Vertex      command_graph_get_last_added_vertex (const Command_Graph graph);
    void                command_graph_sort_by_stat          (const Command_Graph graph);
    void                command_graph_sort_by_keyboard      (const Command_Graph graph);
    void                command_graph_dump_to_text          (const Command_Graph graph,
                                                             FILE *stream);
    void                command_graph_dump_to_binary        (const Command_Graph graph);
    Command_Graph       command_graph_reconstruct_from_binary
                                                            ();

## Description

## Details

### MAX_NUM_PREDICTIONS

    #define MAX_NUM_PREDICTIONS 10

### command_graph_free ()

    void                command_graph_free                  (const Command_Graph graph);

`graph` : |

### command_graph_create ()

    Command_Graph       command_graph_create                ();

Returns : |

### command_graph_add_vertex ()

    void                command_graph_add_vertex            (const Command_Graph graph,
                                                             const Command_Vertex vertex);

`graph` : |
`vertex` : |

### command_graph_get_last_n_added_vertices ()

    const Command_Vertex * command_graph_get_last_n_added_vertices
                                                            (const Command_Graph graph);

`graph` : |
Returns : |

### command_graph_remove_vertex ()

    void                command_graph_remove_vertex         (const Command_Graph graph,
                                                             const Command_Vertex vertex);

`graph` : |
`vertex` : |

### command_graph_get_vertex ()

    Command_Vertex      command_graph_get_vertex            (const Command_Graph graph,
                                                             const Command_Vertex vertex);

`graph` : |
`vertex` : |
Returns : |

### command_graph_size ()

    int                 command_graph_size                  (const Command_Graph graph);

`graph` : |
Returns : |

### command_graph_total_commands ()

    int                 command_graph_total_commands        (const Command_Graph graph);

`graph` : |
Returns : |

### command_graph_get_vertices ()

    Arraylist           command_graph_get_vertices          (const Command_Graph graph);

`graph` : |
Returns : |

### command_graph_get_last_added_vertex ()

    Command_Vertex      command_graph_get_last_added_vertex (const Command_Graph graph);

`graph` : |
Returns : |

### command_graph_sort_by_stat ()

    void                command_graph_sort_by_stat          (const Command_Graph graph);

`graph` : |

### command_graph_sort_by_keyboard ()

    void                command_graph_sort_by_keyboard      (const Command_Graph graph);

`graph` : |

### command_graph_dump_to_text ()

    void                command_graph_dump_to_text          (const Command_Graph graph,
                                                             FILE *stream);

`graph` : |
`stream` : |

### command_graph_dump_to_binary ()

    void                command_graph_dump_to_binary        (const Command_Graph graph);

`graph` : |

### command_graph_reconstruct_from_binary ()

    Command_Graph       command_graph_reconstruct_from_binary
                                                            ();

Returns : |